VERSION 5.00
Begin VB.Form frmPredicateIn 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "In Predicate"
   ClientHeight    =   4140
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   Icon            =   "PredicateIn.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4140
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdRemove 
      Caption         =   "&Remove"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3330
      TabIndex        =   4
      Top             =   3585
      Width           =   1200
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "&Add"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3330
      TabIndex        =   2
      Top             =   3090
      Width           =   1200
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   3360
      TabIndex        =   5
      Top             =   150
      Width           =   1200
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3360
      TabIndex        =   6
      Top             =   570
      Width           =   1200
   End
   Begin VB.Frame fraPredicate 
      Caption         =   "In Predicate"
      Height          =   3855
      Left            =   75
      TabIndex        =   0
      Top             =   105
      Width           =   3150
      Begin VB.CheckBox chkIncludeEmptyString 
         Caption         =   "List includes empty string"
         Height          =   225
         Left            =   105
         TabIndex        =   7
         Top             =   3480
         Width           =   2955
      End
      Begin VB.ListBox lstExpressionList 
         Height          =   2010
         ItemData        =   "PredicateIn.frx":030A
         Left            =   105
         List            =   "PredicateIn.frx":030C
         MultiSelect     =   2  'Extended
         TabIndex        =   3
         Top             =   1230
         Width           =   2955
      End
      Begin VB.TextBox txtIn 
         Height          =   315
         Left            =   105
         TabIndex        =   1
         Top             =   480
         Width           =   2955
      End
      Begin VB.Label lblExpressionList 
         Caption         =   "Expression List"
         Height          =   255
         Left            =   105
         TabIndex        =   9
         Top             =   915
         Width           =   3000
      End
      Begin VB.Label lblIn 
         Caption         =   "In"
         Height          =   255
         Left            =   105
         TabIndex        =   8
         Top             =   225
         Width           =   3000
      End
   End
End
Attribute VB_Name = "frmPredicateIn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Form:       frmPredicateIn - Form for In Predicates
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "frmPredicateIn"

'local copy of properties
Dim m_oPredicateIn                As SQLStudioMan.predicateIn
Dim m_oColDef                     As SQLStudioDBLayer.Column

'local variables
Dim m_oPredicateInCopy            As New SQLStudioMan.predicateIn


Private Sub copyPredicate(DestPredicate As SQLStudioMan.predicateIn, SrcPredicate As SQLStudioMan.predicateIn)
    On Error GoTo errCopyPredicate

    Const FUNCTION_NAME = "copyPredicate"
    
    Dim Value   As Variant
    
    '  Copy predicate
    DestPredicate.arrange = SrcPredicate.arrange
    DestPredicate.isNot = SrcPredicate.isNot
    DestPredicate.includeEmptyString = SrcPredicate.includeEmptyString
    
    For Each Value In SrcPredicate.ValueList
        DestPredicate.AddValue Value
    Next
    
    Exit Sub
    
errCopyPredicate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Public Property Set predicateIn(NewPredicateIn As SQLStudioMan.predicateIn)
    On Error GoTo errP_SET_PredicateIn

    Const FUNCTION_NAME = "P_SET PredicateIn"
    
    Dim Value   As Variant
    
    If NewPredicateIn Is Nothing Then Exit Property
    
    Set m_oPredicateIn = NewPredicateIn
    
    '  Copy predicate
    copyPredicate m_oPredicateInCopy, NewPredicateIn
    
    
    For Each Value In m_oPredicateIn.ValueList
        lstExpressionList.AddItem Value
    Next
    
    If m_oPredicateIn.includeEmptyString Then
        chkIncludeEmptyString = vbChecked
    Else
        chkIncludeEmptyString = vbUnchecked
    End If
    
    '  Is expression list empty?
    If lstExpressionList.ListCount = 0 Then
        cmdRemove.Enabled = False
    Else
        cmdRemove.Enabled = True
    End If
    
    Exit Property
    
errP_SET_PredicateIn:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get predicateIn() As SQLStudioMan.predicateIn
    On Error GoTo errP_Get_PredicateIn

    Const FUNCTION_NAME = "P_Get predicateIn"
    
    Set predicateIn = m_oPredicateIn
    
    Exit Property
    
errP_Get_PredicateIn:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set columnDefinition(NewColumnDefinition As SQLStudioDBLayer.Column)
    On Error GoTo errP_SET_ColumnDefinition

    Const FUNCTION_NAME = "P_SET ColumnDefinition"
    
    Set m_oColDef = NewColumnDefinition
    
    If m_oColDef.sapdbColType = sapdbColTypeChar Or _
       m_oColDef.sapdbColType = sapdbColTypeVarChar _
    Then
        chkIncludeEmptyString.Enabled = True
    Else
        chkIncludeEmptyString.Enabled = False
    End If
       
    Exit Property
    
errP_SET_ColumnDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Private Sub chkIncludeEmptyString_Click()
    On Error GoTo errChkIncludeEmptyString_Click

    Const FUNCTION_NAME = "chkIncludeEmptyString_Click"
    
    If chkIncludeEmptyString.Value = vbChecked Then
    
        m_oPredicateIn.includeEmptyString = True
    Else
        m_oPredicateIn.includeEmptyString = False
    End If
    
    Exit Sub
    
errChkIncludeEmptyString_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME

End Sub

Private Sub cmdAdd_Click()
    On Error GoTo errCmdAdd_Click

    Const FUNCTION_NAME = "cmdAdd_Click"
    
    '  Is there an expression?
    If txtIn.text <> "" Then
        'Add expression to IN list
        If m_oPredicateIn.AddValue(txtIn.text) Then
            'Add expression to list
            lstExpressionList.AddItem txtIn.text
            
            '  Enable remove button
            cmdRemove.Enabled = True
            
            'set focus to textbox
            txtIn.SelStart = 0
            txtIn.SelLength = Len(txtIn.text)
            txtIn.SetFocus
        End If
    End If
    
    If m_oPredicateIn.ValueList.Count > 0 Or _
        ((m_oColDef.sapdbColType = sapdbColTypeChar Or _
          m_oColDef.sapdbColType = sapdbColTypeVarChar) _
            And _
         m_oPredicateIn.includeEmptyString) _
     Then
        cmdOk.Enabled = True
    Else
        cmdOk.Enabled = False
    End If
        
    Exit Sub
    
errCmdAdd_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdCancel_Click
'    description:   the cancel button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdCancel_Click()
    On Error GoTo errCmdCancel_Click

    Const FUNCTION_NAME = "cmdCancel_Click"
    
    'set old predicate values
    copyPredicate m_oPredicateIn, m_oPredicateInCopy
    
    Err.Number = cdlCancel
    
    '  Unload form
    Unload Me
    
    Exit Sub
    
errCmdCancel_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdOk_Click
'    description:   the ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdOk_Click()
    On Error GoTo errCmdOk_Click
    
    Const FUNCTION_NAME = "cmdOk_Click"
       
     If m_oPredicateIn.ValueList.Count > 0 Or _
        ((m_oColDef.sapdbColType = sapdbColTypeChar Or _
          m_oColDef.sapdbColType = sapdbColTypeVarChar) _
            And _
         m_oPredicateIn.includeEmptyString) _
     Then
        Unload Me '  Unload form
        Err.Number = 0
     Else
        txtIn.SetFocus
        Exit Sub
     End If
    
    Exit Sub
    
errCmdOk_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub


Private Sub cmdRemove_Click()
    On Error GoTo errCmdRemove_Click

    Const FUNCTION_NAME = "cmdRemove_Click"
    
    Dim lCount           As Long
    
    lCount = 0
    'scan list
    While lCount < lstExpressionList.ListCount
        '  Is item selected?
        If lstExpressionList.Selected(lCount) Then
            '  Remove item from IN list
            m_oPredicateIn.RemoveValue lstExpressionList.list(lCount)
                            
            lstExpressionList.RemoveItem lCount '  Remove item from list
        Else
            '  Increment index
            lCount = lCount + 1
        End If
    Wend
    
    '  Is expression list empty?
    If lstExpressionList.ListCount = 0 Then
        cmdRemove.Enabled = False
    Else
        cmdRemove.Enabled = True
    End If
            
    'set focus to textbox
    txtIn.SelStart = 0
    txtIn.SelLength = Len(txtIn.text)
    txtIn.SetFocus
    
    If m_oPredicateIn.ValueList.Count > 0 Or _
        ((m_oColDef.sapdbColType = sapdbColTypeChar Or _
          m_oColDef.sapdbColType = sapdbColTypeVarChar) _
            And _
         m_oPredicateIn.includeEmptyString) _
     Then
        cmdOk.Enabled = True
    Else
        cmdOk.Enabled = False
    End If
    
    Exit Sub
    
errCmdRemove_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub


Private Sub txtIn_Change()
    On Error GoTo errTxtIn_Change

    Const FUNCTION_NAME = "txtIn_Change"
    
    If Len(txtIn.text) > 0 Then
        cmdAdd.Enabled = True
    Else
        cmdAdd.Enabled = False
    End If
    
    If Not m_oColDef Is Nothing Then
    
        If m_oPredicateIn.ValueList.Count > 0 Or _
            ((m_oColDef.sapdbColType = sapdbColTypeChar Or _
              m_oColDef.sapdbColType = sapdbColTypeVarChar) _
                And _
             m_oPredicateIn.includeEmptyString) _
        Then
            cmdOk.Enabled = True
        Else
            cmdOk.Enabled = False
        End If
    End If
    
    Exit Sub
    
errTxtIn_Change:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo errForm_Unload

    Const FUNCTION_NAME = "Form_Unload"

    Err.Number = cdlCancel
    
    Exit Sub
    
errForm_Unload:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

